/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       OL_Macros.ctl
//
//  Revisions:  02/15/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) : 
//                         Created 
//  
//  Description: Macro functions to save repetition in panel code
//
/////////////////////////////////////////////////////////////////////////////


//  Sets the Device decsription headers on popup faceplates.
//  Accounts for the possibility of dp being a first level dp, and needing a "." postfix to get the description
//  @dp: $dp 
//  @prefix: Text written before dp description
//  @postfix: Text written after dp description

void SetHeaderText(string dp, string prefix = "", string postfix = "")
{
  if(IsFirstLevelDP(dp))
    {
      setValue("", "text", prefix + dpGetDescription(dp +".") + postfix);
    }
    else
    {
      setValue("", "text", prefix + dpGetDescription(dp) + postfix);
    }
  CheckErrors();
}

// A macro within a macro. Just incase I need it somewhere else
bool IsFirstLevelDP(string dp)
{
  dyn_string dpSplit = strsplit(dpSubStr(dp, DPSUB_DP_EL), ".");
  if (dynlen(dpSplit)<2)
  {
    return true;
  }
  else
  {
    return false;
  }

}

void CheckErrors()
{
  dyn_errClass err;
  err = getLastError();
  if (dynlen(err) > 0)
    setValue("", "color", "_dpdoesnotexist");
}
