/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       IO_AnalogInput.ctl
//
//  Revisions:  01/21/17 - Peter King (peter.king@dmcinfo.com) : 
//                         Created 
//              01/26/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) :
//                         Added constructor, comments and headers
//  
//  Description: Analog Input class
//
/////////////////////////////////////////////////////////////////////////////
    
enum analogInputMode
{
  Auto   = 1,
  Manual = 2
};


enum analogInputStatus
{
  StatusOK            = 0   ,
  InputInvalid        = 101 ,
  HighHighAlarm       = 102 ,
  LowLowAlarm         = 103 ,
  HighWarning         = 104,
  LowWarning          = 105,
  DPDoesNotExist = 200
};

class analogInput
{
  string DP;
  public analogInput(string dp = "unknown")    
  // Device constructor
  {
   DP = dp;
  }
  
  public toManual()
  //  Sets device operating mode to manual
  {
    dpSet(DP + ".iMode", (int) analogInputMode::Manual);
  }
  
  public toAuto()
  //  Sets device operating mode to auto
  {
    dpSet(DP + ".iMode", (int) analogInputMode::Auto);
  }
  
  public resetError()
  //  Resets any device specific operating errors
  {
    dpSet(DP + ".bPB_ResetError", TRUE);
  }
};
