/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       IO_AnalogOutput.ctl
//
//  Revisions:  01/21/17 - Peter King (peter.king@dmcinfo.com) : 
//                         Created 
//              01/26/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) :
//                         Added constructor, comments and headers
//  
//  Description: Analog Output class
//
/////////////////////////////////////////////////////////////////////////////
   
enum analogOutputMode
{
  Auto   = 1,
  Manual = 2
};

enum analogOutputStatus
{
  StatusOK            = 0 ,
  OutOfRange          = 1 ,
  ConfigurationError  = 2 ,
  EStop               = 3 ,
  DPDoesNotExist = 100
};

class analogOutput
{
  public string DP;
  public analogOutput(string dp = "unknown")    
      // Device constructor
  {
    DP= dp;
  }
  
  public toManual()
  {
    dpSet(DP + ".iMode", (int) analogOutputMode::Manual);
  }
  
  public toAuto()
  {
    dpSet(DP + ".iMode", (int) analogOutputMode::Auto);
  }
  
  public resetError()
  {
    dpSet(DP + ".bPB_ResetError", TRUE);
  }
};
