/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       Motor_Reversing.ctl
//
//  Revisions:  01/21/17 - Peter King (peter.king@dmcinfo.com) : 
//                         Created 
//              01/26/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) :
//                         Added constructor, comments and headers               
//  
//  Description: Standard Motor class
//
/////////////////////////////////////////////////////////////////////////////

enum motorMode
{
  Auto   = 1,
  Manual = 2
};

enum motorError
{
  StatusOK            = 0 ,
  MotorProtector      = 1 ,
  LocalDisconnect     = 2 ,
  SignalForward       = 3 ,
  SignalReverse       = 4 ,
  NotStopped          = 5 ,
  Clutch              = 6 ,
  EStop               = 7
};


enum motorState
{
  
  DeviceError         = 0 ,
  DeviceRunning       = 1 ,
  DeviceStopped       = 2 ,
  DeviceStart         = 3 ,
  SignalReverse       = 4 ,
  DPDoesNotExist      = 100 
};

class motorReversing
{  
  string DP;
  public motorReversing(string dp = "unknown")    
  // Device constructor
  {
   DP = dp;
  }
  
  public startFwd()
  {
    dpSet(DP + ".bPB_Forward", TRUE);
  }
  
  public startRev()
  {
    dpSet(DP + ".bPB_Reverse", TRUE);
  }
  
  public stop()
  {
    dpSet(DP + ".bPB_Stop", TRUE);
  }
  
  public resetError()
  {
    dpSet(DP + ".bPB_ResetError", TRUE);
  }
  
  public toManual()
  {
    dpSet(DP + ".iMode", (int) motorMode::Manual);
  }
  
  public toAuto()
  {
    dpSet(DP + ".iMode", (int) motorMode::Auto);
  }
};
