/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       VFD_Gseries.ctl
//
//  Revisions:  01/21/17 - Peter King (peter.king@dmcinfo.com) : 
//                         Created 
//              01/26/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) :
//                         Added constructor, comments and headers               
//  
//  Description: VFD Motor class
//
/////////////////////////////////////////////////////////////////////////////

enum vfdMode{
  Auto = 1,
  Manual = 2
};

enum vfdError
{
  StatusOK            = 0 ,
  MotorProtector      = 1 ,
  LocalDisconnect     = 2 ,
  Clutch              = 3 ,
  CoolingFan          = 4 ,
  Overcurrent         = 5 ,
  MotorOverload       = 6 ,
  VFDOverload         = 7 ,
  GeneralFault        = 8 ,
  NoSignalForward     = 9 ,
  NoSignalReverse     = 10,
  NoContactorFeedback = 11,
  ContactorStillOn    = 12,
  MotorNotStopped     = 13,
  MaxFrequency        = 14,
  EStop               = 15
};

enum vfdState
{
  DeviceError        = 0 ,
  DeviceRunning      = 1 ,
  DeviceStopped      = 2 ,
  DeviceStart        = 3 ,
  DPDoesNotExist = 100
};


class vfdGSeries
{  
  string DP;
  public vfdGSeries(string dp = "unknown")    
  // Device constructor
  {
    DP = dp;
  }
  
  public startFwd()
  {
    dpSet(DP + ".bPB_Forward", TRUE);
  }
  
  public startRev()
  {
    dpSet(DP + ".bPB_Reverse", TRUE);
  }
  
  public stop()
  {
    dpSet(DP + ".bPB_Stop", TRUE);
  }
  
  public resetError()
  {
    dpSet(DP + ".bPB_ResetError", TRUE);
  }
  
  public toManual()
  {
    dpSet(DP + ".iMode", (int)vfdMode::Manual);
  }
  
  public toAuto()
  {
    dpSet(DP + ".iMode", (int)vfdMode::Auto);
  }
};
