/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       IO_Valve_Analog.ctl
//
//  Revisions:  01/21/17 - Peter King (peter.king@dmcinfo.com) : 
//                         Created 
//              01/26/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) :
//                         Added constructor, comments and headers               
//  
//  Description: Analog Valve class
//
/////////////////////////////////////////////////////////////////////////////


enum valveAnalogMode
{
  Auto       = 1, 
  Manual     = 2
};

enum valveAnalogError
{
  StatusOK            = 0 ,
  InvalidFeedback     = 1 ,
  EStop               = 2
};

enum valveAnalogStatus
{
  Stopped     = 0,
  Error       = 1,
  EStop       = 2,
  Work        = 3,
  Home        = 4,
  Independent = 5,
  DPDoesNotExist = 100
};

class valveAnalog
{
  string DP;
  public valveAnalog(string dp = "unknown")    
  // Device constructor
  {
    DP= dp;
  }
  
  public toManual()
  //  Sets device operating mode to manual
  {
    dpSet(DP + ".iMode", (int) valveAnalogMode::Manual);
  }
  
  public toAuto()
  //  Sets device operating mode to auto
  {
    dpSet(DP + ".iMode", (int) valveAnalogMode::Auto);
  }
  
  public resetError()
  //  Resets any device specific operating errors
  {
    dpSet(DP + ".bPB_ResetError", TRUE);
  }
};
