/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       IO_Valve_Solenoid.ctl
//
//  Revisions:  01/21/17 - Peter King (peter.king@dmcinfo.com) : 
//                         Created 
//              01/26/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) :
//                         Added constructor, comments and headers               
//  
//  Description: Solenoid Valve class
//
/////////////////////////////////////////////////////////////////////////////

enum valveSolenoidMode
{
  Auto = 1, 
  Manual = 2
};

enum valveSolenoidError
{
  StatusOK            = 0 ,
  InvalidFeedback     = 1 ,
  EStop               = 2
};

enum valveSolenoidStatus
{
  Off = 0,
  Error = 1,
  Estop = 2,
  Work = 3,
  Home = 4,
  Opening = 5,
  Closing = 6, //~~ TODO LTM ~~: CONFIRM NUMBERS ARE CORRECT
  DPDoesNotExist = 100
};

class valveSolenoid
{
  string DP;
  public valveSolenoid(string dp = "unknown")    
  // Device constructor
  {
    DP = dp;
  }
  
  public toManual()
  {
    dpSet(DP + ".iMode", (int)valveSolenoidMode::Manual);
  }
  
  public toAuto()
  {
    dpSet(DP + ".iMode", (int)valveSolenoidMode::Auto);
  }
  
  public resetError()
  {
    dpSet(DP + ".bPB_ResetError", TRUE);
  }
  
  public toHome()
  {
    dpSet(DP + ".bPB_Home", TRUE);
  }
  
  public toWork()
  {
    dpSet(DP + ".bPB_Work", TRUE);
  }
};
