/////////////////////////////////////////////////////////////////////////////
//
//  WinCC OA Open Library
//  
//  Author:     DMC, Inc. http://www.dmcinfo.com
//
//  File:       PID_CompactInterface.ctl
//
//  Revisions:  01/21/17 - Peter King (peter.king@dmcinfo.com) : 
//                         Created 
//              01/26/17 - Leigh Mathews (leigh.mathews@dmcinfo.com) :
//                         Added constructor, comments and headers               
//  
//  Description: Compact PID
//
/////////////////////////////////////////////////////////////////////////////

enum pidMode{Auto = 1, Manual = 2};
enum pidError
{
  StatusOK                             = 0 ,
  InputOutOfRange                      = 1 ,
  InputPERInvalid                      = 2 ,
  ValueOscillationFailed               = 3 ,
  ProcessValueCloseToSP                = 4 ,
  SPChangedDuringTuning                = 5 ,
  PreTuningDuringFineTuning            = 6 ,
  InvalidOutputValueLimits             = 7 ,
  InvalidFineTuningParameter           = 8 ,
  InputInvalidFormat                   = 9 ,
  OutputCalculationError               = 10,
  SamplingTimeError                    = 11,
  SPInvalidFormat                      = 12,
  ManualInvalidFormat                  = 13,
  SubstituteOutputInvalidFormat        = 14,
  DisturbanceInvalidFormat             = 15,
  EStop                                = 16
};

class pidCompact
{  
  string DP;
  public pidCompact(string dp = "unknown")    
  // Device constructor
  {
    DP = dp;
  }
  
  public toPIDAuto()
  {
    dpSet(DP + ".bPB_AutomaticMode", TRUE);
  }
  
  public toPIDManual()
  {
    dpSet(DP + ".bPB_ManualMode", TRUE);
  }
  
  public preTune()
  {
    dpSet(DP + ".bPB_Pretune", TRUE);
  }
  
  public fineTune()
  {
    dpSet(DP + ".bPB_FineTune", TRUE);
  }
  
  public manualTune()
  {
    dpSet(DP + ".bPB_ManualTuning", TRUE);
  }
    
  public resetError()
  {
    dpSet(DP + ".bPB_ResetError", TRUE);
  }
  
  public toManual()
  {
    dpSet(DP + ".iMode", (int)pidMode::Manual);
  }
  
  public toAuto()
  {
    dpSet(DP + ".iMode", (int)pidMode::Auto);
  }
};
